/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: CloseRelationImpl.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _UTILITY_CLOSE_RELATION_IMPL_HPP_
#define _UTILITY_CLOSE_RELATION_IMPL_HPP_

#include "tops/utilities/CloseContainer/CloseRelation.hpp"

namespace Utility {

	/**
	 * 密関連クラスを実装するために使用できる一般的な密関連テンプレートです。
	 * このテンプレートは、型引数にコンテナの型（例：list）を必要とします。
	 * コンテナの型に必要となる性質を以下に示します。
	 *
	 * 1. コンテナであること。
	 * 2. iterator 型を持っていること。
	 * 3. 2 の iterator 型が不揮発性の反復子であること。
	 * 4. 2 の iterator 型を引数とする erase メソッドを持っていること。
	 *    また、その erase メソッドは反復子が持つ要素をコンテナから削除する効果をもつこと。
	 *
	 * @author トゥイー
	 */
	template<typename ContainerType>
	class CloseRelationImpl : public CloseRelation {
	private:
		ContainerType& m_container;
		typename ContainerType::iterator m_iterator;
		CloseContainer* m_owner;

	public:
		/**
		 * 密関連を構築します。
		 *
		 * @param container コンテナ。
		 * @param iterator 密関連に使用する反復子。
		 * @param owner 密コンテナ。null 不可。
		 */
		CloseRelationImpl(
		    ContainerType& container,
		    const typename ContainerType::iterator& iterator,
		    CloseContainer* owner) :
		m_container(container), m_iterator(iterator), m_owner(owner) {
		}

	public:
		/**
		 * 所属する密コンテナを取得します。
		 *
		 * @return 密関連している場合は所属する密コンテナ、それ以外の場合は NULL。
		 */
		CloseContainer* getOwner() {
			return m_owner;
		}

		/**
		 * 密関連しているかどうかを判断します。
		 *
		 * @return 密関連している場合は true、それ以外の場合は false。
		 */
		bool isOwned() const {
			return m_owner != 0;
		}

		/**
		 * 対象密コンテナを指定して、密関連しているかどうかを判断します。
		 *
		 * @param owner 密コンテナ。
		 * @return 対象密コンテナと密関連している場合は true、それ以外の場合は false。
		 */
		bool isOwned(CloseContainer& owner) const {
			return m_owner == &owner;
		}

		/**
		 * 密関連を解放します。密関連していない場合は何もしません。
		 */
		void release() {
			if (m_owner) {
				CloseContainer* owner = m_owner;
				m_owner = 0;
				m_container.erase(m_iterator);
			}
		}
	};

}  // namespace Utility

#endif
